/* GCC */

#include <iostream>
#include <fstream>
#include <vector>


using namespace std;

const int first=20;
int times;
int n, answer=0;
bool error=false;
int sequence[100000];
vector <bool> was(0, false);

int getNext(int a){
    for(int i=a; i<n*first; i++){
        if (!was[i]) return i;
    }
    return n*first;
}

int buildSubSeq(int a){
    while(a<n*times){
        if (was[a]) {
            error=true;
            return 0;
        }
        was[a]=true;
        a=a+sequence[a%n];
    }
}

int main(){


    ifstream fin("decomp.in");
    ofstream fout("decomp.out");

    //READ FILE
    int i, max=0;
    bool theSame=true;
    fin>>n;
    for(i=0; i<n; i++){
        fin>>sequence[i];
        if (sequence[i]!=sequence[0]) theSame=false;
        if(sequence[i]>max) max=sequence[i];
    }
    if(theSame){
        fout<<sequence[0]<<endl;
        fin.close();
        fout.close();
        return 0;
    }


    //FILL HELPER
    times=first+max/n;
    was=vector<bool>(times*n, false);

    //MAIN PART
    i=0;
    while(i<n*first){
        buildSubSeq(i);
        if (error) {
            fout<<-1<<endl;
            fin.close();
            fout.close();
            return 0;
        }
        i=getNext(i);
        answer++;
    }

    //CHECK IF ALL MEMBERS ARE IN A SUBSEQUENCE
    bool somethingNone=false;
    for(i=0; i<n*times; i++){
        if (!was[i]){
            somethingNone=true;
            break;
        }
    }

    //WRITE TO FILE
    if(!somethingNone){
        fout<<answer<<endl;
    }else{
        fout<<-1<<endl;
    }

    fin.close();
    fout.close();
    return 0;
}
