/* GCC */
#include <iostream>
#include <vector>
#include <fstream>

using namespace std;

typedef unsigned long long ull;

const int VER=12, DAY=61, MAX=1e6+1;
const ull INF=18446744073709551615;

int n=10, days, k;
ull c[VER][DAY];
int pnt[VER];
bool check[MAX];
vector<ull> adp[VER][DAY];
vector<int> arr[VER];

void update(int v, int d)
{
    int num=arr[v].size();
    int still_alive=num;
    for(int i=0; i<num; ++i)
        pnt[i]=0;
    while(still_alive>0)
    {
        ull mn=INF;
        for(int i=0; i<num; ++i)
            if(pnt[i]<adp[arr[v][i]][d-1].size())
                mn=min(adp[arr[v][i]][d-1][pnt[i]], mn);
        adp[v][d].push_back(mn+c[v][d]);
        for(int i=0; i<num; ++i)
            while(adp[arr[v][i]][d-1][pnt[i]]==mn)
            {
                ++pnt[i];
                if(pnt[i]==adp[arr[v][i]][d-1].size())
                {
                    --still_alive;
                    break;
                }
            }
    }
}

int main()
{
    ifstream cin("caves.in");
    ofstream cout("caves.out");
    ios::sync_with_stdio(0);
    cin >> days >> k;
    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=n; ++j)
        {
            bool in;
            cin >> in;
            if(in) arr[i].push_back(j);
        }
    }
    for(int d=1; d<=days; ++d)
        for(int v=1; v<=n; ++v)
            cin >> c[v][d];
    for(int v=1; v<=n; ++v)
        adp[v][1].push_back(c[v][1]);
    for(int d=2; d<=days; ++d)
    {
        for(int v=1; v<=n; ++v)
        {
            update(v, d);
            /*
            cerr << "\t" << v << " " << d << endl;
            for(int i=0; i<adp[v][d].size(); ++i)
                cerr << adp[v][d][i] << " ";
            cerr << endl;
            */
        }
    }
    for(int v=1; v<=n; ++v)
        arr[n+1].push_back(v);
    update(n+1, days+1);
    int ans=adp[n+1][days+1].size();
    ull mn=INF, mx=0;
    for(int i=0; i<k; ++i)
    {
        ull in;
        cin >> in;
        int l=0, r=adp[n+1][days+1].size();
        while(l<r-1)
        {
            int m=(l+r)>>1;
            if(adp[n+1][days+1][m]<=in) l=m;
            else r=m;
        }
        if(adp[n+1][days+1][l]==in)
            check[l]=true, --ans;
    }
    for(int i=0; i<adp[n+1][days+1].size(); ++i)
        if(!check[i])
        {
            if(adp[n+1][days+1][i]<mn) mn=adp[n+1][days+1][i];
            if(adp[n+1][days+1][i]>mx) mx=adp[n+1][days+1][i];
        }
    cout << ans << " " << mx << " " << mn << endl;
    return 0;
}
